package hu.elte.javagyak.gyak13;

public class IntStack {
    private final int[] elements;
    private final int capacity;
    private int pointer = - 1;

    public IntStack(int capacity) {
        if (capacity < 1) {
            throw new IllegalArgumentException("Capacity cannot be negative: " + capacity);
        }
        this.capacity = capacity;
        this.elements = new int[capacity];
    }

    public void push(int element) throws StackOverflowException {
        if (isFull()) {
            throw new StackOverflowException("The stack is full, element cannot be pushed.");
        }
        elements[++pointer] = element;
    }

    public int pop() throws StackIsEmptyException {
        if (isEmpty()) {
            throw new StackIsEmptyException("The stack is empty, there is no element to pop.");
        }
        return elements[pointer--];
    }

    public int size() {
        return pointer + 1;
    }

    public boolean isEmpty() {
        return pointer == -1;
    }

    public boolean isFull() {
        return pointer == capacity - 1;
    }
}