package hu.elte.javagyak.gyak13;

import static org.junit.Assert.assertTrue;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertEquals;
import org.junit.Assert;
import org.junit.Test;

public class IntStackTest {

    @Test(expected = IllegalArgumentException.class)
    public void testConstructorForNegativeCapacity() {
        new IntStack(-1);
    }

    @Test
    public void testPush_IsNotEmpty_IfWePushedOneElement() throws Exception {
        IntStack stack = new IntStack(10);
        stack.push(50);
    
        boolean actual = stack.isEmpty();
        
        assertFalse(stack.isEmpty());
    }
    
    @Test(expected = StackOverflowException.class)
    public void testPush_ThrowsException_IfStackIsFull() throws Exception {
        IntStack stack = new IntStack(1);
        stack.push(666);
    
        stack.push(100);
    }

    @Test
    public void testPop_RemovesElement() throws Exception {
        IntStack stack = new IntStack(1);
        stack.push(666);
    
        stack.pop();
        
        assertFalse(stack.isFull());

    }
    
}
